<?
/*******************************************************************************
*    WMail 1.0. Webmail for PHP                                                *
*    Using DB Framwork for PHP  1.1.                                           *
*    Copyright (C) 2006 Luca Bertoncello                                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

include_once("table.php");
include_once($authSystem);

class Identity extends BaseList
{
  var $name, $addr, $isDefault;

  function Identity($id, $name = '', $addr = '', $isDefault = 'f')
  {
    $this->id = $id;
    $this->className = 'identity';
    $this->name = $name;
    $this->addr = $addr;
    $this->isDefault = $isDefault;
  }

  function checkDataFormDelete($formName, $tClass, $myid)
  {
    foreach($tClass->lines as $line)
    {
      if($line->id == $myid)
      {
        if($line->isDefault == 't')
        {
          $this->errorForm = _('Standardidentit&auml;t kann nicht gel&ouml;scht werden!');
          return false;
        }
      }
    }

    return true;
  }

  function checkDataForm($formName, $tClass)
  {
    global $auth;

    if($_REQUEST[$formName.'_field_addr'] == '')
    {
      $this->errorForm = _('Sie m&uuml;ssen eine Adresse eingeben!');
      return false;
    }
    if(!isValidEmail($_REQUEST[$formName.'_field_addr']))
    {
      $this->errorForm = _('Diese Adresse ist ung&uuml;tig!');
      return false;
    }
    if(canUseAlias($auth, $_REQUEST[$formName.'_field_addr']))
    {
      if($_REQUEST[$formName.'_field_id'] == '')
      {
        foreach($tClass->lines as $line)
        {
          if($line->addr == $_REQUEST[$formName.'_field_addr'])
          {
            $this->errorForm = _('Diese Adresse ist schon eingetragen!');
            return false;
          }
        }
      }
      else
      {
        foreach($tClass->lines as $line)
        {
          if($line->addr == $_REQUEST[$formName.'_field_addr'] && $line->id() != $_REQUEST[$formName.'_field_id'])
          {
            $this->errorForm = _('Diese Adresse ist schon eingetragen!');
            return false;
          }
        }
      }
    }
    else
    {
      $this->errorForm = _('Diese Adresse kann nicht von Ihnen benutzt werden!');
      return false;
    }

    return true;
  }

  function setDataForm($formName, $tClass)
  {
    $this->name = $_REQUEST[$formName.'_field_name'];
    $this->addr = strtolower($_REQUEST[$formName.'_field_addr']);
    $this->isDefault = $_REQUEST[$formName.'_field_isDefault'];
    if(count($tClass->lines) == 0)
      $this->isDefault = 't';
  }

  function display($startTemplate, $endTemplate, $widths = array())
  {
    if($this->isDefault == 't')
    {
      $bold1 = '<b>';
      $bold2 = '</b>';
    }
    $stTem = str_replace('>', ' style="border-left-width:0px;border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
    $stTem = str_replace('%%WIDTH%%', $widths[0], $stTem);
    print "$stTem$bold1".htmlentities($this->name)."$bold2$endTemplate\n";
    $stTem = str_replace('>', ' style="border-right-width:0px;border-bottom-width:0px;border-top-width:0px;">', $startTemplate);
    $stTem = str_replace('%%WIDTH%%', $widths[1], $stTem);
    print "$stTem$bold1".htmlentities($this->addr)."$bold2$endTemplate\n";
  }

  function getFields()
  {
    return array($this->name, $this->addr, $this->isDefault);
  }

  function fields()
  {
    return array('name', 'addr', 'isDefault');
  }

  function displayFieldsForEdit($formName, $field, $selected)
  {
    if($field == 'name')
      print "<INPUT TYPE=\"Text\" SIZE=\"25\" STYLE=\"width:250px;\" NAME=\"$formName"."_field_$field\" VALUE=\"$selected\">";
    if($field == 'addr')
      print "<INPUT TYPE=\"Text\" SIZE=\"25\" STYLE=\"width:240px;\" NAME=\"$formName"."_field_$field\" VALUE=\"$selected\">";
    if($field == 'isDefault')
    {
      if($selected == 't')
        print "<INPUT TYPE=\"CheckBox\" NAME=\"$formName"."_field_$field\" VALUE=\"t\" CHECKED=\"checked\">"._('Standard');
      else
        print "<INPUT TYPE=\"CheckBox\" NAME=\"$formName"."_field_$field\" VALUE=\"t\">"._('Standard');
    }
  }
}
?>
